# Permissions

To allow a seamless collaborative workflow, [Enterprise](https://commercelayer.io/pricing) users can define [custom roles](/provisioning/api-reference/roles.md#custom-roles) and assign permissions to each role created. This allows different [members](/provisioning/api-reference/memberships.md) to have different privileges or different [integration](/provisioning/api-reference/api_credentials.md#integration) API credentials to be granted different permissions on CRUD operations at the single resource level.

Each permission is role and subject-specific, meaning that to [create a new permission](/provisioning/api-reference/permissions/create.md) you need to associate it with a role and specify the single resource involved. For that resource you can define the allowed actions by setting the 4 CRUD boolean attributes (which can be changed at any time):

* `can_read`
* `can_create`
* `can_update`
* `can_delete`

If you want to create a set of permissions involving different resources, you need to create a permission for each resource, associated with the same role.

When fetching a permission, you can check if additional restrictions have been applied by inspecting the `restrictions` object.

{% hint style="info" %}
Existing permissions cannot be deleted using the Provisioning API.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.commercelayer.io/provisioning/api-reference/permissions.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
